#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>

#include "request.h"
#include "myerrors.h"
#include "message.h"
#include "syncchannel.h"
#include "asyncchannel.h"
#include "mytimelib.h"
#include "request_manager.h"
#include "defs.h"
#include "debug.h"
#include "random.h"
#include "tracemanager.h" 
#include "mwmr.h" 
 

#define NB_PROC 5
#define WIDTH 4
#define DEPTH 16

void __user_init() {
}

#include "TestBench.h"
#include "SpeedSensor.h"
#include "RadarSensor.h"
#include "GPSSensor.h"
#include "CarPositionSimulator.h"
#include "EmergencySimulator.h"
#include "Communication.h"
#include "DSRSC_Management.h"
#include "NeighbourhoodTableManagement.h"
#include "CorrectnessChecking.h"
#include "PTC.h"
#include "DrivingPowerReductionStrategy.h"
#include "BCU.h"
#include "DangerAvoidanceStrategy.h"
#include "BrakeManagement.h"
#include "CSCU.h"
#include "ObjectListManagement.h"
#include "PlausibilityCheck.h"
#include "VehiculeDynamicsManagement.h"

/* Main mutex */
pthread_barrier_t barrier ;
pthread_attr_t *attr_t;
pthread_mutex_t __mainMutex;

#define CHANNEL0 __attribute__((section("section_channel0")))
#define LOCK0 __attribute__((section("section_lock0")))
#define CHANNEL1 __attribute__((section("section_channel1")))
#define LOCK1 __attribute__((section("section_lock1")))
#define CHANNEL2 __attribute__((section("section_channel2")))
#define LOCK2 __attribute__((section("section_lock2")))
#define CHANNEL3 __attribute__((section("section_channel3")))
#define LOCK3 __attribute__((section("section_lock3")))
#define CHANNEL4 __attribute__((section("section_channel4")))
#define LOCK4 __attribute__((section("section_lock4")))
#define CHANNEL5 __attribute__((section("section_channel5")))
#define LOCK5 __attribute__((section("section_lock5")))
#define CHANNEL6 __attribute__((section("section_channel6")))
#define LOCK6 __attribute__((section("section_lock6")))
#define CHANNEL7 __attribute__((section("section_channel7")))
#define LOCK7 __attribute__((section("section_lock7")))
#define CHANNEL8 __attribute__((section("section_channel8")))
#define LOCK8 __attribute__((section("section_lock8")))
#define CHANNEL9 __attribute__((section("section_channel9")))
#define LOCK9 __attribute__((section("section_lock9")))
#define CHANNEL10 __attribute__((section("section_channel10")))
#define LOCK10 __attribute__((section("section_lock10")))
#define CHANNEL11 __attribute__((section("section_channel11")))
#define LOCK11 __attribute__((section("section_lock11")))
#define CHANNEL12 __attribute__((section("section_channel12")))
#define LOCK12 __attribute__((section("section_lock12")))
#define CHANNEL13 __attribute__((section("section_channel13")))
#define LOCK13 __attribute__((section("section_lock13")))
#define CHANNEL14 __attribute__((section("section_channel14")))
#define LOCK14 __attribute__((section("section_lock14")))
#define base(arg) arg

typedef struct mwmr_s mwmr_t;

/* Synchronous channels */
syncchannel __DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency;
uint32_t const DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_lock LOCK0;
struct mwmr_status_s DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_status CHANNEL0;
uint8_t DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_data[32] CHANNEL0;
struct mwmr_s DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency CHANNEL0;

syncchannel __NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList;
uint32_t const NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_lock LOCK0;
struct mwmr_status_s NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_status CHANNEL0;
uint8_t NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_data[32] CHANNEL0;
struct mwmr_s NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList CHANNEL0;

syncchannel __DangerAvoidanceStrategy_brakePower__BrakeManagement_brake;
uint32_t const DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_lock LOCK0;
struct mwmr_status_s DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_status CHANNEL0;
uint8_t DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_data[32] CHANNEL0;
struct mwmr_s DangerAvoidanceStrategy_brakePower__BrakeManagement_brake CHANNEL0;

syncchannel __DangerAvoidanceStrategy_brake__PlausibilityCheck_brake;
uint32_t const DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_lock LOCK0;
struct mwmr_status_s DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_status CHANNEL0;
uint8_t DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_data[32] CHANNEL0;
struct mwmr_s DangerAvoidanceStrategy_brake__PlausibilityCheck_brake CHANNEL0;

syncchannel __PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed;
uint32_t const PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_lock LOCK0;
struct mwmr_status_s PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_status CHANNEL0;
uint8_t PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_data[32] CHANNEL0;
struct mwmr_s PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed CHANNEL0;

syncchannel __SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed;
uint32_t const SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_lock LOCK0;
struct mwmr_status_s SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_status CHANNEL0;
uint8_t SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_data[32] CHANNEL0;
struct mwmr_s SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed CHANNEL0;

syncchannel __PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle;
uint32_t const PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_lock LOCK0;
struct mwmr_status_s PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_status CHANNEL0;
uint8_t PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_data[32] CHANNEL0;
struct mwmr_s PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle CHANNEL0;

syncchannel __RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead;
uint32_t const RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_lock LOCK0;
struct mwmr_status_s RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_status CHANNEL0;
uint8_t RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_data[32] CHANNEL0;
struct mwmr_s RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead CHANNEL0;

syncchannel __CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify;
uint32_t const CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_lock LOCK0;
struct mwmr_status_s CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_status CHANNEL0;
uint8_t CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_data[32] CHANNEL0;
struct mwmr_s CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify CHANNEL0;

syncchannel __DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage;
uint32_t const DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_lock LOCK0;
struct mwmr_status_s DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_status CHANNEL0;
uint8_t DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_data[32] CHANNEL0;
struct mwmr_s DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage CHANNEL0;

syncchannel __DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode;
uint32_t const DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_lock LOCK0;
struct mwmr_status_s DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_status CHANNEL0;
uint8_t DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_data[32] CHANNEL0;
struct mwmr_s DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode CHANNEL0;

syncchannel __CarPositionSimulator_carPosition__DSRSC_Management_carPosition;
uint32_t const CarPositionSimulator_carPosition__DSRSC_Management_carPosition_lock LOCK0;
struct mwmr_status_s CarPositionSimulator_carPosition__DSRSC_Management_carPosition_status CHANNEL0;
uint8_t CarPositionSimulator_carPosition__DSRSC_Management_carPosition_data[32] CHANNEL0;
struct mwmr_s CarPositionSimulator_carPosition__DSRSC_Management_carPosition CHANNEL0;

syncchannel __EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected;
uint32_t const EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_lock LOCK0;
struct mwmr_status_s EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_status CHANNEL0;
uint8_t EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_data[32] CHANNEL0;
struct mwmr_s EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected CHANNEL0;

syncchannel __GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition;
uint32_t const GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_lock LOCK0;
struct mwmr_status_s GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_status CHANNEL0;
uint8_t GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_data[32] CHANNEL0;
struct mwmr_s GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition CHANNEL0;

/* Asynchronous channels */
asyncchannel __DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder;
uint32_t const DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_lock LOCK0;
struct mwmr_status_s DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_status CHANNEL0;
uint8_t DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_data[32] CHANNEL0;
struct mwmr_s DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder CHANNEL0;


int main(int argc, char *argv[]) {
  
  
  void *ptr;
  pthread_barrier_init(&barrier,NULL, NB_PROC);
  pthread_attr_t *attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_init(attr_t);
  pthread_mutex_init(&__mainMutex, NULL);
  
  /* Synchronous channels */
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_status.rptr = 0;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_status.wptr = 0;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_status.usage = 0;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_status.lock = 0;
  
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.width = 1;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.depth = 1;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.gdepth = 1;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.buffer = DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_data;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.status = &DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_status;
  
  __DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.inname ="broadcastEmergencyBrakingMessage";
  __DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.outname ="forwardEmergency";
  __DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.mwmr_fifo = &DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.status =&DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency_status;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.status->lock=0;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.status->rptr=0;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.status->usage=0;
  DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency.status->wptr =0;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_status.rptr = 0;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_status.wptr = 0;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_status.usage = 0;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_status.lock = 0;
  
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.width = 1;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.depth = 1;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.gdepth = 1;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.buffer = NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_data;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.status = &NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_status;
  
  __NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.inname ="getNodeList";
  __NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.outname ="sendTable";
  __NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.mwmr_fifo = &NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.status =&NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList_status;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.status->lock=0;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.status->rptr=0;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.status->usage=0;
  NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList.status->wptr =0;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_status.rptr = 0;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_status.wptr = 0;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_status.usage = 0;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_status.lock = 0;
  
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.width = 1;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.depth = 1;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.gdepth = 1;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.buffer = DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_data;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.status = &DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_status;
  
  __DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.inname ="brake";
  __DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.outname ="brakePower";
  __DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.mwmr_fifo = &DangerAvoidanceStrategy_brakePower__BrakeManagement_brake;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.status =&DangerAvoidanceStrategy_brakePower__BrakeManagement_brake_status;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.status->lock=0;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.status->rptr=0;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.status->usage=0;
  DangerAvoidanceStrategy_brakePower__BrakeManagement_brake.status->wptr =0;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_status.rptr = 0;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_status.wptr = 0;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_status.usage = 0;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_status.lock = 0;
  
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.width = 1;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.depth = 1;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.gdepth = 1;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.buffer = DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_data;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.status = &DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_status;
  
  __DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.inname ="brake";
  __DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.outname ="brake";
  __DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.mwmr_fifo = &DangerAvoidanceStrategy_brake__PlausibilityCheck_brake;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.status =&DangerAvoidanceStrategy_brake__PlausibilityCheck_brake_status;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.status->lock=0;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.status->rptr=0;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.status->usage=0;
  DangerAvoidanceStrategy_brake__PlausibilityCheck_brake.status->wptr =0;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_status.rptr = 0;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_status.wptr = 0;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_status.usage = 0;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_status.lock = 0;
  
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.width = 1;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.depth = 1;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.gdepth = 1;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.buffer = PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_data;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.status = &PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_status;
  
  __PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.inname ="getInfoOnSpeed";
  __PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.outname ="getInfoOnSpeed";
  __PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.mwmr_fifo = &PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.status =&PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed_status;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.status->lock=0;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.status->rptr=0;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.status->usage=0;
  PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed.status->wptr =0;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_status.rptr = 0;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_status.wptr = 0;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_status.usage = 0;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_status.lock = 0;
  
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.width = 1;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.depth = 1;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.gdepth = 1;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.buffer = SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_data;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.status = &SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_status;
  
  __SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.inname ="updateOnSpeed";
  __SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.outname ="updateOnSpeed";
  __SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.mwmr_fifo = &SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.status =&SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed_status;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.status->lock=0;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.status->rptr=0;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.status->usage=0;
  SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed.status->wptr =0;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_status.rptr = 0;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_status.wptr = 0;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_status.usage = 0;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_status.lock = 0;
  
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.width = 1;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.depth = 1;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.gdepth = 1;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.buffer = PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_data;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.status = &PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_status;
  
  __PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.inname ="getInfoOnObstacle";
  __PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.outname ="getInfoOnObstacle";
  __PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.mwmr_fifo = &PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.status =&PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle_status;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.status->lock=0;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.status->rptr=0;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.status->usage=0;
  PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle.status->wptr =0;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_status.rptr = 0;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_status.wptr = 0;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_status.usage = 0;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_status.lock = 0;
  
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.width = 1;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.depth = 1;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.gdepth = 1;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.buffer = RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_data;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.status = &RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_status;
  
  __RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.inname ="isObstacleAhead";
  __RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.outname ="obstacleAhead";
  __RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.mwmr_fifo = &RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.status =&RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead_status;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.status->lock=0;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.status->rptr=0;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.status->usage=0;
  RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead.status->wptr =0;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_status.rptr = 0;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_status.wptr = 0;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_status.usage = 0;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_status.lock = 0;
  
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.width = 1;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.depth = 1;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.gdepth = 1;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.buffer = CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_data;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.status = &CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_status;
  
  __CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.inname ="getEmergencyMessageToVerify";
  __CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.outname ="toPlausibityCheckMessage";
  __CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.mwmr_fifo = &CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.status =&CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify_status;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.status->lock=0;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.status->rptr=0;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.status->usage=0;
  CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify.status->wptr =0;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_status.rptr = 0;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_status.wptr = 0;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_status.usage = 0;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_status.lock = 0;
  
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.width = 1;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.depth = 1;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.gdepth = 1;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.buffer = DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_data;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.status = &DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_status;
  
  __DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.inname ="getEmergencyBrakingMessage";
  __DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.outname ="forwardEmergencyBrakingMessage";
  __DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.mwmr_fifo = &DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.status =&DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage_status;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.status->lock=0;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.status->rptr=0;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.status->usage=0;
  DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage.status->wptr =0;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_status.rptr = 0;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_status.wptr = 0;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_status.usage = 0;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_status.lock = 0;
  
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.width = 1;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.depth = 1;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.gdepth = 1;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.buffer = DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_data;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.status = &DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_status;
  
  __DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.inname ="addANode";
  __DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.outname ="setCarPosition";
  __DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.mwmr_fifo = &DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.status =&DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode_status;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.status->lock=0;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.status->rptr=0;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.status->usage=0;
  DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode.status->wptr =0;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition_status.rptr = 0;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition_status.wptr = 0;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition_status.usage = 0;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition_status.lock = 0;
  
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.width = 1;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.depth = 1;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.gdepth = 1;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.buffer = CarPositionSimulator_carPosition__DSRSC_Management_carPosition_data;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.status = &CarPositionSimulator_carPosition__DSRSC_Management_carPosition_status;
  
  __CarPositionSimulator_carPosition__DSRSC_Management_carPosition.inname ="carPosition";
  __CarPositionSimulator_carPosition__DSRSC_Management_carPosition.outname ="carPosition";
  __CarPositionSimulator_carPosition__DSRSC_Management_carPosition.mwmr_fifo = &CarPositionSimulator_carPosition__DSRSC_Management_carPosition;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.status =&CarPositionSimulator_carPosition__DSRSC_Management_carPosition_status;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.status->lock=0;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.status->rptr=0;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.status->usage=0;
  CarPositionSimulator_carPosition__DSRSC_Management_carPosition.status->wptr =0;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_status.rptr = 0;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_status.wptr = 0;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_status.usage = 0;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_status.lock = 0;
  
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.width = 1;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.depth = 1;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.gdepth = 1;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.buffer = EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_data;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.status = &EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_status;
  
  __EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.inname ="obstacleDetected";
  __EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.outname ="obstacleDetected";
  __EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.mwmr_fifo = &EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.status =&EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected_status;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.status->lock=0;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.status->rptr=0;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.status->usage=0;
  EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected.status->wptr =0;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_status.rptr = 0;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_status.wptr = 0;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_status.usage = 0;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_status.lock = 0;
  
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.width = 1;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.depth = 1;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.gdepth = 1;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.buffer = GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_data;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.status = &GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_status;
  
  __GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.inname ="setPosition";
  __GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.outname ="setPosition";
  __GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.mwmr_fifo = &GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.status =&GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition_status;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.status->lock=0;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.status->rptr=0;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.status->usage=0;
  GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition.status->wptr =0;
  /* Asynchronous channels */
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_status.rptr = 0;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_status.wptr = 0;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_status.usage = 0;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_status.lock = 0;
  
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.width = 1;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.depth = 11;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.gdepth = DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.depth;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.buffer = DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_data;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.status = &DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_status;
  __DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.inname ="getReducePowerOrder";
  __DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.outname ="reducePower";
  __DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.isBlocking = 0;
  __DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.maxNbOfMessages = 1;
  __DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.mwmr_fifo = &DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.status =&DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder_status;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.status->lock=0;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.status->rptr=0;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.status->usage=0;
  DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder.status->wptr=0;
  
  /* Threads of tasks */
  pthread_t thread__TestBench;
  pthread_t thread__SpeedSensor;
  pthread_t thread__RadarSensor;
  pthread_t thread__GPSSensor;
  pthread_t thread__CarPositionSimulator;
  pthread_t thread__EmergencySimulator;
  pthread_t thread__Communication;
  pthread_t thread__DSRSC_Management;
  pthread_t thread__NeighbourhoodTableManagement;
  pthread_t thread__CorrectnessChecking;
  pthread_t thread__PTC;
  pthread_t thread__DrivingPowerReductionStrategy;
  pthread_t thread__BCU;
  pthread_t thread__DangerAvoidanceStrategy;
  pthread_t thread__BrakeManagement;
  pthread_t thread__CSCU;
  pthread_t thread__ObjectListManagement;
  pthread_t thread__PlausibilityCheck;
  pthread_t thread__VehiculeDynamicsManagement;
  /* Activating tracing  */
  if (argc>1){
    activeTracingInFile(argv[1]);
  } else {
    activeTracingInConsole();
  }
  /* Activating randomness */
  initRandom();
  /* Initializing the main mutex */
if (pthread_mutex_init(&__mainMutex, NULL) < 0) { exit(-1);}
  
  /* User initialization */
  __user_init();
  
  
  struct mwmr_s *channels_array_TestBench;
  ptr =malloc(sizeof(pthread_t));
  thread__TestBench= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 4);  
  
  
  pthread_create(&thread__TestBench, attr_t, mainFunc__TestBench, (void *)channels_array_TestBench);
  
  struct mwmr_s *channels_array_SpeedSensor[1];
  channels_array_SpeedSensor[0]=&SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed;
  
  ptr =malloc(sizeof(pthread_t));
  thread__SpeedSensor= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 4);  
  
  
  pthread_create(&thread__SpeedSensor, attr_t, mainFunc__SpeedSensor, (void *)channels_array_SpeedSensor);
  
  struct mwmr_s *channels_array_RadarSensor[1];
  channels_array_RadarSensor[0]=&RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead;
  
  ptr =malloc(sizeof(pthread_t));
  thread__RadarSensor= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 4);  
  
  
  pthread_create(&thread__RadarSensor, attr_t, mainFunc__RadarSensor, (void *)channels_array_RadarSensor);
  
  struct mwmr_s *channels_array_GPSSensor[1];
  channels_array_GPSSensor[0]=&GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition;
  
  ptr =malloc(sizeof(pthread_t));
  thread__GPSSensor= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 4);  
  
  
  pthread_create(&thread__GPSSensor, attr_t, mainFunc__GPSSensor, (void *)channels_array_GPSSensor);
  
  struct mwmr_s *channels_array_CarPositionSimulator[1];
  channels_array_CarPositionSimulator[0]=&CarPositionSimulator_carPosition__DSRSC_Management_carPosition;
  
  ptr =malloc(sizeof(pthread_t));
  thread__CarPositionSimulator= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 4);  
  
  
  pthread_create(&thread__CarPositionSimulator, attr_t, mainFunc__CarPositionSimulator, (void *)channels_array_CarPositionSimulator);
  
  struct mwmr_s *channels_array_EmergencySimulator[1];
  channels_array_EmergencySimulator[0]=&EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected;
  
  ptr =malloc(sizeof(pthread_t));
  thread__EmergencySimulator= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 4);  
  
  
  pthread_create(&thread__EmergencySimulator, attr_t, mainFunc__EmergencySimulator, (void *)channels_array_EmergencySimulator);
  
  struct mwmr_s *channels_array_Communication;
  ptr =malloc(sizeof(pthread_t));
  thread__Communication= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 1);  
  
  
  pthread_create(&thread__Communication, attr_t, mainFunc__Communication, (void *)channels_array_Communication);
  
  struct mwmr_s *channels_array_DSRSC_Management[5];
  channels_array_DSRSC_Management[0]=&DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency;
  channels_array_DSRSC_Management[1]=&DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage;
  channels_array_DSRSC_Management[2]=&DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode;
  channels_array_DSRSC_Management[3]=&CarPositionSimulator_carPosition__DSRSC_Management_carPosition;
  channels_array_DSRSC_Management[4]=&EmergencySimulator_obstacleDetected__DSRSC_Management_obstacleDetected;
  
  ptr =malloc(sizeof(pthread_t));
  thread__DSRSC_Management= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 1);  
  
  
  pthread_create(&thread__DSRSC_Management, attr_t, mainFunc__DSRSC_Management, (void *)channels_array_DSRSC_Management);
  
  struct mwmr_s *channels_array_NeighbourhoodTableManagement[3];
  channels_array_NeighbourhoodTableManagement[0]=&NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList;
  channels_array_NeighbourhoodTableManagement[1]=&DSRSC_Management_setCarPosition__NeighbourhoodTableManagement_addANode;
  channels_array_NeighbourhoodTableManagement[2]=&GPSSensor_setPosition__NeighbourhoodTableManagement_setPosition;
  
  ptr =malloc(sizeof(pthread_t));
  thread__NeighbourhoodTableManagement= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 1);  
  
  
  pthread_create(&thread__NeighbourhoodTableManagement, attr_t, mainFunc__NeighbourhoodTableManagement, (void *)channels_array_NeighbourhoodTableManagement);
  
  struct mwmr_s *channels_array_CorrectnessChecking[2];
  channels_array_CorrectnessChecking[0]=&CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify;
  channels_array_CorrectnessChecking[1]=&DSRSC_Management_forwardEmergencyBrakingMessage__CorrectnessChecking_getEmergencyBrakingMessage;
  
  ptr =malloc(sizeof(pthread_t));
  thread__CorrectnessChecking= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 1);  
  
  
  pthread_create(&thread__CorrectnessChecking, attr_t, mainFunc__CorrectnessChecking, (void *)channels_array_CorrectnessChecking);
  
  struct mwmr_s *channels_array_PTC;
  ptr =malloc(sizeof(pthread_t));
  thread__PTC= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 2);  
  
  
  pthread_create(&thread__PTC, attr_t, mainFunc__PTC, (void *)channels_array_PTC);
  
  struct mwmr_s *channels_array_DrivingPowerReductionStrategy[1];
  channels_array_DrivingPowerReductionStrategy[0]=&DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder;
  
  ptr =malloc(sizeof(pthread_t));
  thread__DrivingPowerReductionStrategy= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 2);  
  
  
  pthread_create(&thread__DrivingPowerReductionStrategy, attr_t, mainFunc__DrivingPowerReductionStrategy, (void *)channels_array_DrivingPowerReductionStrategy);
  
  struct mwmr_s *channels_array_BCU;
  ptr =malloc(sizeof(pthread_t));
  thread__BCU= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 3);  
  
  
  pthread_create(&thread__BCU, attr_t, mainFunc__BCU, (void *)channels_array_BCU);
  
  struct mwmr_s *channels_array_DangerAvoidanceStrategy[4];
  channels_array_DangerAvoidanceStrategy[0]=&DSRSC_Management_broadcastEmergencyBrakingMessage__DangerAvoidanceStrategy_forwardEmergency;
  channels_array_DangerAvoidanceStrategy[1]=&DangerAvoidanceStrategy_reducePower__DrivingPowerReductionStrategy_getReducePowerOrder;
  channels_array_DangerAvoidanceStrategy[2]=&DangerAvoidanceStrategy_brakePower__BrakeManagement_brake;
  channels_array_DangerAvoidanceStrategy[3]=&DangerAvoidanceStrategy_brake__PlausibilityCheck_brake;
  
  ptr =malloc(sizeof(pthread_t));
  thread__DangerAvoidanceStrategy= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 3);  
  
  
  pthread_create(&thread__DangerAvoidanceStrategy, attr_t, mainFunc__DangerAvoidanceStrategy, (void *)channels_array_DangerAvoidanceStrategy);
  
  struct mwmr_s *channels_array_BrakeManagement[1];
  channels_array_BrakeManagement[0]=&DangerAvoidanceStrategy_brakePower__BrakeManagement_brake;
  
  ptr =malloc(sizeof(pthread_t));
  thread__BrakeManagement= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 3);  
  
  
  pthread_create(&thread__BrakeManagement, attr_t, mainFunc__BrakeManagement, (void *)channels_array_BrakeManagement);
  
  struct mwmr_s *channels_array_CSCU;
  ptr =malloc(sizeof(pthread_t));
  thread__CSCU= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 0);  
  
  
  pthread_create(&thread__CSCU, attr_t, mainFunc__CSCU, (void *)channels_array_CSCU);
  
  struct mwmr_s *channels_array_ObjectListManagement[2];
  channels_array_ObjectListManagement[0]=&PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle;
  channels_array_ObjectListManagement[1]=&RadarSensor_obstacleAhead__ObjectListManagement_isObstacleAhead;
  
  ptr =malloc(sizeof(pthread_t));
  thread__ObjectListManagement= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 0);  
  
  
  pthread_create(&thread__ObjectListManagement, attr_t, mainFunc__ObjectListManagement, (void *)channels_array_ObjectListManagement);
  
  struct mwmr_s *channels_array_PlausibilityCheck[5];
  channels_array_PlausibilityCheck[0]=&NeighbourhoodTableManagement_sendTable__PlausibilityCheck_getNodeList;
  channels_array_PlausibilityCheck[1]=&DangerAvoidanceStrategy_brake__PlausibilityCheck_brake;
  channels_array_PlausibilityCheck[2]=&PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed;
  channels_array_PlausibilityCheck[3]=&PlausibilityCheck_getInfoOnObstacle__ObjectListManagement_getInfoOnObstacle;
  channels_array_PlausibilityCheck[4]=&CorrectnessChecking_toPlausibityCheckMessage__PlausibilityCheck_getEmergencyMessageToVerify;
  
  ptr =malloc(sizeof(pthread_t));
  thread__PlausibilityCheck= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 0);  
  
  
  pthread_create(&thread__PlausibilityCheck, attr_t, mainFunc__PlausibilityCheck, (void *)channels_array_PlausibilityCheck);
  
  struct mwmr_s *channels_array_VehiculeDynamicsManagement[2];
  channels_array_VehiculeDynamicsManagement[0]=&PlausibilityCheck_getInfoOnSpeed__VehiculeDynamicsManagement_getInfoOnSpeed;
  channels_array_VehiculeDynamicsManagement[1]=&SpeedSensor_updateOnSpeed__VehiculeDynamicsManagement_updateOnSpeed;
  
  ptr =malloc(sizeof(pthread_t));
  thread__VehiculeDynamicsManagement= (pthread_t)ptr;
  attr_t = malloc(sizeof(pthread_attr_t));
  pthread_attr_affinity(attr_t, 0);  
  
  
  pthread_create(&thread__VehiculeDynamicsManagement, attr_t, mainFunc__VehiculeDynamicsManagement, (void *)channels_array_VehiculeDynamicsManagement);
  
  
  
  pthread_join(thread__TestBench, NULL);
  pthread_join(thread__SpeedSensor, NULL);
  pthread_join(thread__RadarSensor, NULL);
  pthread_join(thread__GPSSensor, NULL);
  pthread_join(thread__CarPositionSimulator, NULL);
  pthread_join(thread__EmergencySimulator, NULL);
  pthread_join(thread__Communication, NULL);
  pthread_join(thread__DSRSC_Management, NULL);
  pthread_join(thread__NeighbourhoodTableManagement, NULL);
  pthread_join(thread__CorrectnessChecking, NULL);
  pthread_join(thread__PTC, NULL);
  pthread_join(thread__DrivingPowerReductionStrategy, NULL);
  pthread_join(thread__BCU, NULL);
  pthread_join(thread__DangerAvoidanceStrategy, NULL);
  pthread_join(thread__BrakeManagement, NULL);
  pthread_join(thread__CSCU, NULL);
  pthread_join(thread__ObjectListManagement, NULL);
  pthread_join(thread__PlausibilityCheck, NULL);
  pthread_join(thread__VehiculeDynamicsManagement, NULL);
  
  
  return 0;
  
}
